
/*===============================================*\
	Mardi 3 novembre 1998

	Arash HABIBI

	Emission.c

	Lit un fichier et l'ecrit dans un autre
	fichier. La meme chose que cp. 

\*================================================*/


#include "SocketToolbox.h"
#include "CodageDecodage.h"
#include "Erreur.h"
#include <unistd.h>


void SendMessage(int desc_sock, char *message, int taille_message, struct sockaddr_un adresse_dist)
/*===============================================*\
  message est une chaine non-codee. Autrement dit, 
  elle ne contient que de l'information utile. 
  Cette fonction prepare le message code (fonction
  codage)et envoie le message code' sur la socket.
\*===============================================*/
{
  char message_code[MAX_MSG_CODE];
  int res, taille_msg_code;

  Codage(message, taille_message, message_code, &taille_msg_code); 

  res = sendto(desc_sock, message_code, 
	       taille_msg_code, 0, 
	       (struct sockaddr*) &adresse_dist, 
	       sizeof(adresse_dist));

  if(res==-1) {perror("sendto emetteur"); exit(1);}
}
  


void DisconnectRequest(int desc_sock, struct sockaddr_un adresse_dist)
/*===============================================*\
  Envoie un message ne contenant qu'un seul 
  caractere '.' pour informer le recepteur que 
  la transmission est terminee. 
\*===============================================*/
{
  int res; 

  res = sendto(desc_sock, ".", 1, 0, 
	       (struct sockaddr*) &adresse_dist, 
	       sizeof(adresse_dist));

  if(res==-1) {perror("sendto deconnect"); exit(1);}
}


int main(int argc, char **argv)
/*===============================================*\
  Ouvre et prepare une socket unix, ouvre un 
  fichier en lecture, lit le fichier et l'envoie 
  sur la socket avec la fonction SendMessage() qui 
  est definie ci-dessus. 
\*===============================================*/
{
    int ReadFile, taille, desc_sock; 
    struct sockaddr_un adresse_dist; 
    mode_t mode; 
    char message[MAX_MESSAGE];
	
    if(argc!=2)
	{printf("Usage : emetteur FichAEmettre \n");
	 exit(1);}


/* ----- Ouverture en lecture du fichier a envoyer -------*/

    mode = S_IRUSR|S_IWUSR; 

    if((ReadFile=open(argv[1], O_RDONLY, mode))==-1)
      {perror(argv[1]); exit(1);}

        
/* ----- Creation et attachement de la socket locale ------*/
/* -- et preparation de l'adresse de la socket distante ---*/

    desc_sock = GetAndBindSocket("sock_emit");
    adresse_dist = PrepareAdresse("s_medemit"); 
    
    
/* ----- Transmission -------------------------------------*/
	
    while((taille = read(ReadFile, message, MAX_MESSAGE))>0)
      SendMessage(desc_sock, message, taille, adresse_dist);


/* ----- Fin de la transmission----------------------------*/
	
    if(taille<0)
      {perror("read"); exit(1);}
    else /*taille=0*/
      {
	printf("Emission terminee.\n");
	DisconnectRequest(desc_sock, adresse_dist); 	
	close(desc_sock);
	close(ReadFile);
	remove("sock_emit"); 
      }
    return 0;
}
