
/*===============================================*\

	Mardi 3 novembre 1998

	Arash HABIBI

	Erreur.c

	Introduit des erreurs dans les trames.
	C'est un modele de cable non-fiable. 
	Soit des erreurs de bits soit des erreurs
	de caracteres. 

\*================================================*/


#include "Erreur.h"
#include "Logic.h"
#include <stdio.h>


void IntroduitErreur(char *chaine, int taille, int TypeDErreur)
/*===============================================*\
\*===============================================*/
{
  if(TypeDErreur==0)/* n'introduit aucune erreur */; 
  else if(TypeDErreur==1) IntroduitErreur1(chaine, taille); 
  else if(TypeDErreur==2) IntroduitErreur2(chaine, taille); 
  else if(TypeDErreur==3) IntroduitErreur3(chaine, taille); 
  else if(TypeDErreur==4) IntroduitErreur4(chaine, taille); 
  else {printf("%d : type d'erreur inconnue.\n",TypeDErreur); exit(1);}
}


void IntroduitErreur1(char *chaine, int taille)
/*===============================================*\
  Dans chaque caractere bloc de deux octets change 
  un bit au hasard.
  Attention si on change un bit dans chaque 
  caractere, alors ca fait plus qu'une erreur par
  caractere code et Hamming ne pourra plus la 
  detecter (!!!)
\*===============================================*/
{
  int i, exposant;
  unsigned char mask; 

  for(i=0; i<taille; i+=2)
    {
      exposant = (int)floor(drand48() * 16); 
      if(exposant<8)
	{
	  mask = 1<<exposant; 
	  chaine[i] = OuExclusif(chaine[i], mask);
	}
      else
	{
	  mask = 1<<(exposant-8); 
	  chaine[i+1] = OuExclusif(chaine[i+1], mask);
	}
    }
}



void IntroduitErreur2(char *chaine, int taille)
/*===============================================*\
  Pour TAUX_ERREUR=1 change un bit au hasard dans
  tous les caracteres de la chaine. 
  Pour TAUX_ERREUR=0 ne change rien du tout. 
  Entre les deux valeurs, toutes les situations 
  intermediaires sont possibles. 
\*===============================================*/
{
  int i, exposant; 
  unsigned char mask; 

  for(i=0; i<taille; i++)
    if(drand48()<TAUX_ERREUR)
      {
	exposant = (int)floor(drand48() * 16); 
	if(exposant<8)
	  {
	    mask = 1<<exposant; 
	    chaine[i] = OuExclusif(chaine[i], mask);
	  }
	else
	  {
	    mask = 1<<(exposant-8); 
	    chaine[i+1] = OuExclusif(chaine[i+1], mask);
	  }
      }
}




void IntroduitErreur3(char *chaine, int taille)
/*===============================================*\
  Change un caractere au hasard dans chaque chaine. 
\*===============================================*/
{
  int indice, offset; 

  indice = (int)floor(drand48() * taille); 
  offset = (int)floor(drand48() * 256); 
  chaine[indice] = (chaine[indice] + offset )%256; 
}


void IntroduitErreur4(char *chaine, int taille)
/*===============================================*\
  Pour TAUX_ERREUR=1 change tous les caracteres 
  dans chaine.  
  Pour TAUX_ERREUR=0 ne change rien du tout. 
  Entre les deux valeurs, toutes les situations 
  intermediaires sont possibles. 
\*===============================================*/
{
  int i, offset;

  for(i=0; i<taille; i++)
      if(drand48()<TAUX_ERREUR)
	{
	  offset = (int)floor(drand48() * 256); 
	  chaine[i] = (chaine[i] + offset )% 256; 
	}
}

